/*
    dp : An implementation of the davis puttnam procedure for solving
         propositional satisfiability problems.
    Copyright (C) 1993  Peter Barth

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ------------------------------------------------------------------
   SILIST.H
* -------------------------------------------------------------------
* Auth: pb
* Purp: single linked lists with integers as keys (Sedgewick)
* Hist:==============================================================
* Date         Name    What has been done ?!
* -------------------------------------------------------------------
* 10.4.93       pb      creation (for dp)
* ---------------------------------------------------------------- */

#ifndef _silist_h
#define _silist_h

#include "stddef.h" 
#include "stdlib.h"

typedef struct _sinode {
  int key;
  struct _sinode* next;
} *silist;

silist init_silist();

int free_silist(silist head);

silist si_insafter(silist is,int i);

silist si_delnext(silist si);

int si_len(silist si);

int si_dith(silist si,int dith);


/* some special fast routines  */

silist si_fastcopy(silist si);

/* no free on list item */
#define si_fastdelnext(si) (si->next = si->next->next)


#endif
